<!-- forms\admin_framework\admin_server_main.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html>
	<head>
		<style type="text/css">
			<change:wsletExpander>
				<!-- WSLET CODE=PTInclude -->
				<!-- PARAM NAME=styles/default.css -->
				<!-- PARAM NAME=styles/tabs.css -->
				<!-- /WSLET -->
			</change:wsletExpander>
		</style>
		
		<script type="text/javascript">
			var loadAgain = false;
			
			/**
			 * Loads the clicked frame
			 */			
			function tabOnclick(a)
			{
				if (a.disabled)
				{
					return;
				}
				
				if (hasPropertiesFrameModified() 
					&& !confirm("<change:resource key='err00074'/>"))
				{
					return;
				}
				else if (hasPropertiesFrameModified()) 
				{
					loadPropertiesFrame();
				}
				
				var li = a.parentNode;
				var siblings = li.parentNode.getElementsByTagName("li");
			
				for (var i = 0; i < siblings.length; i++)
				{
					var sibling = siblings[i];
			
					if (sibling == li)
					{
						sibling.getElementsByTagName("a")[0].className = "current";
						displayCorrectIFrame(i);
					}
					else
					{
						sibling.getElementsByTagName("a")[0].className = "";
					}
				}
			}
			
			/**
			 * Display the iframe that needs to be displayed and hide the others.
			 * 0 = Properties
			 * 1 = Remote Servers
			 */
			function displayCorrectIFrame(selectedIndex)
			{
				if (selectedIndex == 0)
				{
					document.getElementById("propertiesFrame").style.display = "";
					document.getElementById("CentralServersFrame").style.display = "none";
				}
				else if (selectedIndex == 1)
				{
					document.getElementById("propertiesFrame").style.display = "none";
					
					// Hide the visble data as page will be reloaded freshly.
					if (${isRemoteServer} && loadAgain)
					{
						var centralServerBody = top.frames["dialog"].frames["workspace"].frames["CentralServersFrame"];
							
						if (centralServerBody)
						{
							centralServerBody = centralServerBody.document.centralServerForm;
							centralServerBody.style.display = "none";
						}
					}					
					else if (${isCentralServer} && loadAgain)
					{
						var remoteServersTable = top.frames["dialog"].frames["workspace"].frames["CentralServersFrame"];
						
						if (remoteServersTable)
						{	
							remoteServersTable = remoteServersTable.document.getElementById("remoteServersTable");						
							remoteServersTable.style.display = "none";
						}						
					}
					
					loadAgain = true;
					
					loadCentralServersFrame();
					document.getElementById("CentralServersFrame").style.display = "";
				}
			}
			
			
			/**
			 * Loads the properties frame
			 */						
			function loadPropertiesFrame()
			{
				window.document.propertiesFormLoader.action = "<change:urlCreator webResource='PTWEB'/>";
				window.document.propertiesFormLoader.submit();
			}
			
			/**
			 * Loads the central server's frame
			 */			
			function loadCentralServersFrame()
			{
				var formLoader = window.document.centralServerFormLoader;
				
				<c:if test="${isCentralServer}">
					formLoader.formName.value = "central";
					formLoader.methodToCall.value = "executeCentralServerAction";
				</c:if>
				
				<c:if test="${isRemoteServer}">
					formLoader.formName.value = "remote";
					formLoader.methodToCall.value = "executeRemoteServerAction";
				</c:if>
				
				window.document.centralServerFormLoader.submit();
			}

			
			/**
			 * Check for modification in the Properties tab
			 */
			function hasPropertiesFrameModified()
			{
				// Call javascript functions from iframe through "contentWindow" property.
				var propertiesFrame = document.getElementById("propertiesFrame").contentWindow;
				
				if (propertiesFrame.hasModifications())
				{
					return true
				}
				
				return false;
			}
		</script>
	</head>
	<body onload="loadPropertiesFrame()">
		<table class="barHeading" width="100%">
		<tr>
			<th>
				<change:resource key='lbl01081'/>
			</th>
		</tr>
		</table>
		
		<div id="tabs">
			<ul id="tabsList" class="tabbedList">
				<li>
					<a id="propertiesTab" href="#" onclick="tabOnclick(this);" class="current"><change:resource key="propertiesTabTitle"/></a>
				</li>
				<li>
					<a id="remoteServersTab" href="#" onclick="tabOnclick(this);">
						<c:if test="${isCentralServer}">
							<change:resource key="remoteServers"/>
						</c:if>
						<c:if test="${isRemoteServer}">
							<change:resource key="centralServer"/>
						</c:if>
					</a>
				</li>
			</ul>
		</div>
		
		<iframe src="<change:urlCreator webResource='JS'/>dojo/dojo/resources/blank.html" name="propertiesFrame" id="propertiesFrame" frameborder="0" style="width: 100%; height: 85%; padding: 0px; margin: 0px;"></iframe>
		<iframe src="<change:urlCreator webResource='JS'/>dojo/dojo/resources/blank.html" name="CentralServersFrame" id="CentralServersFrame" frameborder="0" style="width: 100%; height: 85%; padding: 0px; margin: 0px; display: none"></iframe>
		
		<form name="propertiesFormLoader" class="hiddenForm" method="POST" target="propertiesFrame">
			<input name="ACTION_FLAG" type="hidden" value="frameset_form">
			<input name="TEMPLATE_FLAG" type="hidden" value="TransServerView">
			
			<!-- Change Security Data -->
			<input name="role" type="hidden" value="${user.role}">
			<input name="token" type="hidden" value="${user.token}">
			<input name="formName" type="hidden" value="adminServerTab">
		</form>
		
		<form name="centralServerFormLoader" action="<change:urlCreator webResource='BASEURL'/>/centralServerFormLoader.do" class="hiddenForm" method="GET" target="CentralServersFrame">
			<input name="token" type="hidden" value="${user.token}">
			<input name="formName" type="hidden" value="">
			<input name="methodToCall" type="hidden" value="">
		</form>
	</body>
</html>
