<!-- forms\admin_framework\current_system_load_section_details.jsp -->
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>

<%--
	current_system_load_section_details.jsp page displays the information about the
	Current System Load on the given IBM Rational Change server
--%>
<c:choose>
	<c:when test='${!error}'>
		<table>
			<tr id="${serverSysInfo.serverName}">
				<td>
					<table>
						<tr>
							<td style="padding-left:10px;">
								<table id="curSysLoad" cellspacing="0" class="sysLoad-table">
									<tr style="text-align: center" id="sort-on-header">
										<td id="sysLoad-td1">
											<a href="javascript:sortCurrentSysLoad('body-curSysLoad', 'sysLoad-td1')"
												class="sort-header" style="text-decoration: underline">
												<change:resource key="systemLoadDatabase"/></a>
										</td>
										<c:set var="totalActiveUserCount" value="0" scope="session" />
										<c:set var="totalCmSessionCount" value="0" scope="session" />
										
										<c:forEach items="${serverSysInfo.databaseObjects}" var="database">
											<c:if test="${database.activeStatus == 1}">
												<c:set var="totalCmSessionCount" value="${totalCmSessionCount + database.cmSessionCount}" />
												<c:set var="totalActiveUserCount" value="${totalActiveUserCount + database.activeUserCount}"/>
											</c:if>											
										</c:forEach>
										
										<c:choose>
											<c:when test="${totalCmSessionCount == 0 && totalActiveUserCount == 0}">
												<td id="sysLoad-td2" class="sort-header">
													<change:resource key="systemLoadActiveUsers"/>
												</td>
												<td id="sysLoad-td3" class="sort-header">
													<change:resource key="systemLoadCmSessions"/>
												</td>
											</c:when>
											<c:otherwise>
												<c:choose>
													<c:when test="${totalCmSessionCount != 0 && totalActiveUserCount != 0}">
														<td id="sysLoad-td2">
															<a href="javascript:sortCurrentSysLoad('body-curSysLoad', 'sysLoad-td2');" id="href1"
															class="sort-header" style="text-decoration: underline">
															<change:resource key="systemLoadActiveUsers"/></a>
														</td>
														<td id="sysLoad-td3">
															<a href="javascript:sortCurrentSysLoad('body-curSysLoad', 'sysLoad-td3')" id="href2"
															class="sort-header" style="text-decoration: underline">
															<change:resource key="systemLoadCmSessions"/></a>
														</td>
													</c:when>
													<c:otherwise>
														<c:if test="${totalActiveUserCount != 0}">
															<td id="sysLoad-td2">
																<a href="javascript:sortCurrentSysLoad('body-curSysLoad', 'sysLoad-td2');" id="href1"
																class="sort-header" style="text-decoration: underline">
																<change:resource key="systemLoadActiveUsers"/></a>
															</td>
															<td id="sysLoad-td3" class="sort-header">
																<change:resource key="systemLoadCmSessions"/>
															</td>
														</c:if>
														<c:if test="${totalCmSessionCount != 0}">
															<td id="sysLoad-td2" class="sort-header">
																<change:resource key="systemLoadActiveUsers"/>
															</td>
															<td id="sysLoad-td3">
																<a href="javascript:sortCurrentSysLoad('body-curSysLoad', 'sysLoad-td3')" id="href2"
																class="sort-header" style="text-decoration: underline">
																<change:resource key="systemLoadCmSessions"/></a>
															</td>
														</c:if>
													</c:otherwise>
												</c:choose>
											</c:otherwise>
										</c:choose>
									</tr>
									<tbody id="body-curSysLoad" style="text-align: center;">
										<c:forEach items="${serverSysInfo.databaseObjects}" var="dbDetails" varStatus="status">
											<c:set var="divId" value="user-${status.index}" />
											<c:set var="db" value="${dbDetails.database}"/>
											<c:choose>
												<c:when test="${dbDetails.activeStatus == 1}">
													<tr>
														<td style="text-align: left;">
															<c:choose>
																<c:when test="${db == centralCrDbName}">
																	<change:resource key="centralCrDatabaseLbl">
																		<change:param>${dbDetails.databaseAlias}</change:param>
																	</change:resource>	 
																</c:when>
																<c:otherwise>
																	${dbDetails.databaseAlias}
																</c:otherwise>
															</c:choose>
														</td>
														<c:if test="${dbDetails.activeUserCount == 0}">
															<td>
																${dbDetails.activeUserCount}
															</td>
														</c:if>
						
														<c:if test="${dbDetails.activeUserCount != 0}">
															<td>
																<a href='javascript:showDiv("${divId}")'
																	style="text-decoration: underline">${dbDetails.activeUserCount}</a>
															</td>
														</c:if>
						
														<c:set var="divId" value="sessions-${status.index}" />
														<c:if test="${dbDetails.cmSessionCount == 0}">
															<td>
																${dbDetails.cmSessionCount}
															</td>
														</c:if>										
														<c:if test="${dbDetails.cmSessionCount != 0}">
															<td>
																<a href='javascript:showDiv("${divId}")'
																	style="text-decoration: underline">${dbDetails.cmSessionCount}</a>
															</td>
														</c:if>
														</tr>
													</c:when>
													<c:otherwise>
														<tr name="disabledDatabaseRow">
															<td style="text-align: left;">
																<c:choose>
																	<c:when test="${db == centralCrDbName}">
																		<change:resource key="centralCrDatabaseLbl">
																			<change:param>${dbDetails.databaseAlias}</change:param>
																		</change:resource>	 
																	</c:when>
																	<c:otherwise>
																		${dbDetails.databaseAlias}
																	</c:otherwise>
																</c:choose>
															</td>
															<td style="color:red; text-align: center;" colspan="2">
																<change:resource key="disabledDatabase"/>
															</td>
														</tr>
													</c:otherwise>
												</c:choose>	
										</c:forEach>		
									</tbody>
									
									<c:forEach items="${serverSysInfo.databaseObjects}" var="dbDetails" varStatus="status">
										<c:if test="${status.last}">
											<tfoot style="text-align: center;">
												<tr id="total">
													<td style="text-align: left;">
														<change:resource key="total"/>
													</td>
													<c:choose>
														<c:when test="${totalCmSessionCount != 0}">
															<c:if test="${totalActiveUserCount != 0}">
																<td>
																	<a href='javascript:showDiv("total-users")' style="text-decoration: underline">${totalActiveUserCount}</a>
																</td>
															</c:if>
															<c:if test="${totalActiveUserCount == 0}">
																<td style="text-align: center;">		
																	<change:resource key="notApplicable"/>
																</td>
															</c:if>	
															<td>		
																<a href='javascript:showDiv("total-sessions")' style="text-decoration: underline">${totalCmSessionCount}</a>
															</td>
														</c:when>
														<c:otherwise>
															<c:choose>
																<c:when test="${totalActiveUserCount != 0}">
																	<td>
																		<a href='javascript:showDiv("total-users")' style="text-decoration: underline">${totalActiveUserCount}</a>
																	</td>
																	<td style="text-align: center;">		
																		<change:resource key="notApplicable"/>
																	</td>
																</c:when>
																<c:otherwise>
																	<td colspan="2" style="text-align: center;">
																		<change:resource key="notApplicable"/>
																	</td>
																</c:otherwise>
															</c:choose>
														</c:otherwise>	
													</c:choose>
												</tr>
											</tfoot>
										</c:if>
									</c:forEach>
								</table>
							</td>
							<td valign="top">
								<table>
									<tr>
										<td style="text-align: right; padding-left: 25px;">
											<span class="label_decoration" title="<change:resource key="memoryUsageToolTip"/>">
												<change:resource key="memoryUsage"/>
											</span>
										 </td>
										 <td style="text-align: left; padding-left: 0;">
											${serverSysInfo.memoryUsage}
										 </td>
									 </tr>
									<tr>
										<td style="text-align: right;">
											<span class="label_decoration" title="<change:resource key="threadCountToolTip"/>">
												<change:resource key="threadCount" />
											</span>
										 </td>
										 <td style="text-align: left; padding-left: 0;">
										   ${serverSysInfo.threadCount}
										 </td>
									 </tr>
									<c:set var="disableHost">
										 ${serverSysInfo.disabledHostsString}
									</c:set>
									<c:if test="${disableHost != ''}" >
										<tr>
											<td style="text-align: right;">
												<span class="label_decoration" title="<change:resource key="disabledHostToolTip"/>">
													<change:resource key="disabledHost" />
												</span>
											 </td>
											 <td style="color:red; text-align: left;">
												${serverSysInfo.disabledHostsString}
											 </td>
										 </tr>
									</c:if>
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td style="padding-left:15px;" id="${serverSysInfo.serverName}-details">
					<c:forEach items="${serverSysInfo.databaseObjects}" var="dbDetails" varStatus="status">
						<c:if test="${dbDetails.activeStatus == 1}">
							<c:set var="database">
								${dbDetails.databaseAlias}
							</c:set>
								<c:set var="divId" value="user-${status.index}" />
						
								<div id='${divId}' style="display: none; padding-top: 15px">
									<table id="user" class="sysLoad-table" style="padding-top: 10px">
										<thead id="section-user">
											<tr>
												<th colspan="5">
													<table style="background-color: #EEE; border-spacing: 0em;" width="100%">
														<tr>
															<th style="text-align: left;">
																<change:resource key="systemLoadActiveUsersForX">
																	<change:param>${database}</change:param>
																</change:resource>
															</th>
															<th style="text-align: right;">
																<a href='javascript:exitDiv("${divId}")'
																	style="text-decoration: underline;">
																	<change:resource key="lbl00120"/></a>
															</th>
														</tr>
													</table>
												</th>
											</tr>
										</thead>
										<tr style="text-align: center" id='sort-on-${divId}'>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="realName"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="userId"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="userRole"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="usersLastAccess"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="usersTimeOut"/></a>
											</td>
										</tr>
										<tbody id='body-user-${status.index}'>
											<c:forEach items="${dbDetails.userList}" var="user">
												<tr>
													<td>${user.realName}</td>
													<td>${user.userName}</td>
													<td>${user.prettyRole}</td>
													<td>${user.formattedLastAccessedDate}</td>
													<td>${user.formattedTimeoutDate}</td>
												</tr>
											</c:forEach>
										</tbody>
									</table>
								</div>
								<c:set var="totalUsers">
									total-users
								</c:set>
								
								<div id='${totalUsers}' style="display: none; padding-top: 15px">
									<table id="totalUsers" class="sysLoad-table" style="padding-top: 10px">
										<thead id="section-total">
											<tr>
												<th colspan="6">
													<table style="background-color: #EEE; border-spacing: 0em;" width="100%">
														<tr>
															<th style="text-align: left;">
																<change:resource key="allUserForDatabse"/>
															</th>
															<th style="text-align: right;">
																<a href='javascript:exitDiv("total-users")'
																	style="text-decoration: underline">
																	<change:resource key="lbl00120"/></a>
															</th>
														</tr>
													</table>
												</th>
											</tr>
										</thead>
										<tr style="text-align: center" id='sort-on-${totalUsers}'>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="realName"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="userId"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="userRole"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="usersLastAccess"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="usersTimeOut"/></a>
											</td>
											<td>
												<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
												<change:resource key="systemLoadDatabase"/></a>
											</td>
										</tr>
										<tbody id="body-total-users">
											<c:forEach items="${serverSysInfo.databaseObjects}" var="totalUsers">
												<c:if test="${totalUsers.activeStatus == 1}">
													<c:set var="dbName" value="${totalUsers.databaseAlias}"/>
													<c:forEach items="${totalUsers.userList}" var="user">
														<tr>
															<td>${user.realName}</td>
															<td>${user.userName}</td>
															<td>${user.prettyRole}</td>
															<td>${user.formattedLastAccessedDate}</td>
															<td>${user.formattedTimeoutDate}</td>
															<td>${dbName}</td>
														</tr>
													</c:forEach>
												</c:if>
											</c:forEach>
										</tbody>
									</table>
								</div>
							</c:if>
							
							<c:if test="${dbDetails.cmSessionCount != 0}">
							<c:set var="divId" value="sessions-${status.index}" />
							<div id='${divId}' style="display: none; padding-top: 15px">
								<table id="sessions" class="sysLoad-table" style="padding-top: 10px">
									<thead id="section-sessions">
										<tr>
											<th colspan="5">
												<table style="background-color: #EEE; border-spacing: 0em;" width="100%">
													<tr>
														<th style="text-align: left;">
															<change:resource key="systemLoadCmSessionsForX">
																<change:param>${database}</change:param>
															</change:resource>
														</th>
														<th style="text-align: right;">
															<a href='javascript:exitDiv("${divId}")'
																style="text-decoration: underline">
																<change:resource key="lbl00120"/></a>
														</th>
													</tr>
												</table>
											</th>
										</tr>
									</thead>
									<tr style="text-align: center" id='sort-on-${divId}'>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="cmSessionId"/></a>
										</td>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="cmHost"/></a>
										</td>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="hostAddress"/></a>
										</td>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="createdTime"/></a>
										</td>
									</tr>
									<tbody id='body-sessions-${status.index}'>
										<c:forEach items="${dbDetails.sessionList}" var="cmsession">
											<tr>
												<td>${cmsession.sessionId}</td>
												<td>${cmsession.hostName}</td>
												<td>${cmsession.hostAddress}</td>
												<td>${cmsession.creationDate}</td>
											</tr>
										</c:forEach>
									</tbody>
								</table>
							</div>
						</c:if>
						
						<c:if test="${cmSessionCount != 0}">
							<c:set var="divId">
								total-sessions
							</c:set>
								
							<div id='${divId}' style="display: none; padding-top: 15px">
								<table id="totalSessions" class="sysLoad-table" style="padding-top: 10px">
									<thead id="section-total1">
										<tr>
											<th colspan="5">
												<table style="background-color: #EEE; border-spacing: 0em;" width="100%">
													<tr>
														<th style="text-align: left;">
															<change:resource key="cmsessionForAllDatabse"/>
														</th>
														<th style="text-align: right;">
															<a href='javascript:exitDiv("${divId}")'
																style="text-decoration: underline">
																<change:resource key="lbl00120"/></a>
														</th>
													</tr>
												</table>
											</th>
										</tr>
									</thead>
									<tr style="text-align: center" id='sort-on-${divId}'>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="cmSessionId"/></a>
										</td>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="cmHost"/></a>
										</td>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="hostAddress"/></a>
										</td>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="createdTime"/></a>
										</td>
										<td>
											<a href="#" class="sort-header" style="text-decoration: underline" nowrap="nowrap">
											<change:resource key="systemLoadDatabase"/></a>
										</td>
									</tr>
									<tbody id="body-total-sessions">
										<c:forEach items="${serverSysInfo.databaseObjects}" var="totalCmSessions">
											<c:if test="${totalCmSessions.activeStatus == 1}"> 
												<c:set var="dbName" value="${totalCmSessions.databaseAlias}"/>
												<c:forEach items="${totalCmSessions.sessionList}" var="cmsession">
													<tr>
														<td>${cmsession.sessionId}</td>
														<td>${cmsession.hostName}</td>
														<td>${cmsession.hostAddress}</td>
														<td>${cmsession.creationDate}</td>
														<td>${dbName}</td>
													</tr>
												</c:forEach>
												</c:if>
										</c:forEach>	
									</tbody>
								</table>
							</div>
						</c:if>								
					</c:forEach>
				</td>
			</tr>
		</table>
	</c:when>
	<c:otherwise>
		<table width="100%">
			<tr>
				<td style="padding-left: 10px">
					<table width="100%" cellspacing="0" cellpadding="0" border="1" class="sys-section">
						<tr>
							<td width="20%" align="center" valign="middle">
								<img src='<change:urlCreator webResource='PTIMAGES'/>ws_erroricon.gif'>
							</td>
							<td width="80%" valign="middle" style="color:red; padding-left: 15px">
								${errorMessage}
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
	</c:otherwise>
</c:choose>

	

