<!-- forms\user_framework\home_page_loader.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html>
<head>
	<title></title>
	
	<style type="text/css">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=styles/default.css -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=styles/report.css -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		.dojoDndItemBefore 
		{
			border-top: 2px solid #369;
		}
		
		.dojoDndItemAfter 
		{
			border-bottom: 2px solid #369;
		}
		
		table.reportItem
		{
			background-color: #FFFFFF;
		}
		
		div.dropzone
		{
			width: 100%;
			min-height: 15px;
			text-align: center;
		}
		
		div.reportHandle 
		{
			background-color: rgb(225,238,255);
		    cursor: move;
			margin: 3px;
			padding: 5px;
			width: 98%;
		}
		
		span.link
		{
			cursor: pointer;
			text-decoration: underline;
			color: blue;
		}
		
		td.center
		{
			text-align: center;
		}
	</style>
	
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
	<script type="text/javascript" src="dwr/interface/HomePageUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>

	<script type="text/javascript">
		dojo.require("dojo.dnd.common");
		dojo.require("dojo.dnd.Source");
		dojo.require("dojo.fx");
		
		dojo.registerModulePath("custom", "../../customDojo");
		
		dojo.require("custom.HomePageAvatar");
		dojo.require("custom.HomePageSource");
	</script>
		
	<script type="text/javascript">
	
<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=Arrays.js -->
	<!-- PARAM NAME=MessageFormat.js -->
	<!-- PARAM NAME=domUtilities.js -->
	<!-- /WSLET -->
</change:wsletExpander>

<%-- 
	Creating a JavaScript datastructure so it can be looped through and the reports
    can be reloaded.
--%>
var homePage = new Object();
homePage.name = <change:javaScriptEscape value="${homePage.name}"/>;
homePage.pageLayout = <change:javaScriptEscape value="${homePage.pageLayout}"/>;
homePage.adminDefined = ${homePage.adminDefined};
homePage.reports = new Array();
<c:forEach items="${homePage.homePageReports}" var="reportItem" varStatus="status">
homePage.reports[${status.index}] = new Object();
homePage.reports[${status.index}].name = <change:javaScriptEscape value="${reportItem.name}"/>;
homePage.reports[${status.index}].dropArea = <change:javaScriptEscape value="${reportItem.dropArea}"/>;
homePage.reports[${status.index}].sortPosition = <change:javaScriptEscape value="${reportItem.sortPosition}"/>;
</c:forEach>

var asAdmin = ${asAdmin};
var currentlyLoadingReport = 0;
var cancelLoading = false;
var currentRequestId = -1;

var token = "${user.token}";
var database = <change:javaScriptEscape value="${user.database}"/>;
var role = <change:javaScriptEscape value="${user.role}"/>;

function markAsUserHomePage()
{
	//If the home page is admin defined and the user is not acting as an admin then the home page
	//is one that was assigned to them. Mark the home page as being user defined.
	if (homePage.adminDefined && !asAdmin)
	{
		homePage.adminDefined = false;
		
		//enable delete button?\
		var homePageDeleteLink = dojo.byId("homePageDelete");
		
		homePageDeleteLink.disabled = false;
		homePageDeleteLink.style.color= "blue";
		homePageDeleteLink.style.cursor= "pointer";
		homePageDeleteLink.href = "javascript: deleteHomePage_onclick()";
	}
}
	
function editHomePage_onclick()
{
	window.document.createHomePage.homePageTitle.value = <change:javaScriptEscape value="${homePage.name}"/>;
	window.document.createHomePage.submit();
}

function deleteHomePage_onclick()
{
	if (!confirm("<change:resource key="deleteHomePageConfirm"/>")) return;

	HomePageUtilsAjax.removeHomePage("${user.token}", homePage.adminDefined, homePage.name, callback);
	
	function callback(resultHTML)
	{
		document.write(resultHTML);
		document.close();
	};
}

function deleteReport_onclick(reportName)
{
	var reportsLength = homePage.reports.length;
	
	//Delete the home page is only one report is left and they want to remove it.
	if (reportsLength == 1)
	{
		deleteHomePage_onclick();
		return;
	}
	
	if (!confirm("<change:resource key="deleteHomePageReportConfirm"/>")) return;
	
	var index;
	
	for (var i = 0; i < reportsLength; i++)
	{
		if (reportName == homePage.reports[i].name)
		{
			index = i;
			break;
		}
	}
	
	HomePageUtilsAjax.removeHomePageReport("${user.token}", homePage.adminDefined, asAdmin, homePage.name, reportName, callback);
	
	function callback(results)
	{
		if (results.length != 0)
		{
			alert(results);
			return;
		}		
		
		Arrays.removeElement(homePage.reports, index);
		
		var element = dojo.byId("report_" + reportName);
		var parent = element.parentNode;	
		parent.removeChild(element);
		
		markAsUserHomePage();
		highlightEmptyReportSections();
	};
}

function editReport_onclick(reportName)
{
	window.document.editHomePageReport.homePageName.value = <change:javaScriptEscape value="${homePage.name}"/>;
	window.document.editHomePageReport.homePageReportName.value = reportName;
	
	window.document.editHomePageReport.submit();
}

function afterOnDrop(e)
{
	var beginning = "report_";
	var current = 0;
	
	var newHomePageOrder = new Array();
	
	//For each potential drop area (max of 4)
	for (var i = 1; i <= 4; i++)
	{
		var currentDropArea = "drop" + i;
		var dropArea = document.getElementById(currentDropArea);
		var sortPosition = 0;
	
		if (!dropArea)
		{
			continue;
		}
		
		var length = dropArea.childNodes.length;
		
		for (var x = 0; x < length; x++)
		{
			var child = dropArea.childNodes[x];
			
			//if child has id and the id start with "report_" then process that report.
			if (child.id && (child.id.match(/^report_.*/i) != null))
			{
				var reportName = child.id.substr(beginning.length, child.id.length);
				newHomePageOrder[current] = new Object();
				newHomePageOrder[current].name = reportName;
				newHomePageOrder[current].dropArea = currentDropArea;
				newHomePageOrder[current].sortPosition = sortPosition;
				current++;
				sortPosition++;
			}
		}
	}
	
	highlightEmptyReportSections();
	
	HomePageUtilsAjax.updateSortOrder("${user.token}", homePage.adminDefined, asAdmin, homePage.name, newHomePageOrder, callback);
	
	function callback(results)
	{
		if (results.length != 0)
		{
			alert(results);
			return;
		}
		
		markAsUserHomePage();
	};
}

function highlightEmptyReportSections()
{
	//For each potential drop area (max of 4)
	for (var i = 1; i <= 4; i++)
	{
		var currentDropArea = "drop" + i;
		var dropArea = document.getElementById(currentDropArea);
		var sortPosition = 0;
	
		if (!dropArea)
		{
			continue;
		}
		
		var isIE = dojo.isIE;	
		var length = dropArea.childNodes.length;
		
		if ((!isIE && length == 1) || (isIE && length == 0))
		{
	
			dropArea.style.border = "1px dashed gray";
			dropArea.style.width = "100%";
			
			if (dropArea.clientWidth < 20)
			{
				dropArea.style.width = "50px";
			}
		}
		else
		{
			dropArea.style.border = "";
			dropArea.style.width = "100%";
		}
	}
}

function createReportDiv(report)
{
	//Begin header section
	var headerContainer = document.createElement("div");
	headerContainer.className = "reportHandle";
	headerContainer.style.textAlign = "left";
	
	var table = document.createElement("table");
	table.width = "100%"
	table.cellSpacing="0";
	table.cellPadding="0";
	table.border="0";
	
	var tableBody = document.createElement("tbody");

	var tr = document.createElement("tr");
	var td = document.createElement("td");
	td.id = report.name + "_name";
	var text = document.createTextNode(report.name);
	td.appendChild(text);
	tr.appendChild(td);
	
	var td2 = document.createElement("td");
	td2.style.textAlign = "right";
	
	//Using span with onclick since href has drag problems.
	var spanEdit = document.createElement("span");
	spanEdit.onclick = function(){editReport_onclick(report.name);};
	spanEdit.innerHTML = "<change:resource key="editHomePage"/>";
	spanEdit.className = "link";
	spanEdit.id = report.name + "_spanEdit";

	var spanDelete = document.createElement("span");
	spanDelete.onclick  = function(){deleteReport_onclick(report.name);};
	spanDelete.innerHTML = "<change:resource key="deleteHomePage"/>";
	spanDelete.className = "link";

	td2.appendChild(spanEdit);
	td2.appendChild(document.createTextNode(" | "));
	td2.appendChild(spanDelete);
	
	tr.appendChild(td2);
	
	tableBody.appendChild(tr);
	table.appendChild(tableBody);
	
	headerContainer.appendChild(table);
	//End header section
	
	//To make report heading as handle for dragging
	var handleContainer = document.createElement("div");
	handleContainer.className = "dojoDndHandle";
	handleContainer.appendChild(headerContainer);
	
	//Begin report section
	var reportContainer = document.createElement("div");
	reportContainer.width = "98%";
	reportContainer.style.margin = "3px";
	reportContainer.style.padding = "7px";
	reportContainer.style.textAlign = "left";
	
	var image = document.createElement("img");
	image.src = "<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif";
	
	var waitText = document.createTextNode(" <change:resource key='lbl00110'/>");

	reportContainer.appendChild(image);
	reportContainer.appendChild(waitText);
	reportContainer.id = report.name + "_text";
	//End report section
	
	//Add all the pieces together.	
	var mainContainer = document.createElement("div");
	mainContainer.appendChild(handleContainer);
	mainContainer.appendChild(reportContainer);
	mainContainer.id = "report_" + report.name;
	mainContainer.className = "dojoDndItem";
		
	return mainContainer;
}

function loadReports(failSilently)
{	
	if (cancelLoading)
	{
		return;
	}
	
	var currentPage;
	
	if (currentlyLoadingReport < homePage.reports.length)
	{
		currentPage = homePage.reports[currentlyLoadingReport].name;
		HomePageUtilsAjax.getReportRequest("${user.token}", currentPage, longIdCallBack);
	}
	else
	{
		highlightEmptyReportSections();
		currentRequestId = -1;
	}
	
	function longIdCallBack(longRequestId)
	{
		if (longRequestId == "")
		{
			//check for bogus long request and then load the next report.
			currentlyLoadingReport++;
			loadReports(false);
			return;
		}
		
		currentRequestId = longRequestId;
		
		HomePageUtilsAjax.runHomePageReport("${user.token}", longRequestId, homePage.adminDefined, asAdmin, homePage.name, currentPage, callback);
		
		function callback(results)
		{
			if (results.length != 0)
			{
				var pattern = /<!-- count = (\d*) -->/;
				var result = pattern.exec(results);
				var count = RegExp.$1;
					
				if (count.length == 0)
				{
					count = 0;
				}
				
				var messageSubsitutionValues = new Array();
				messageSubsitutionValues[0] = count;
				
				var td = dojo.byId(currentPage + "_name")
				var formatter = new MessageFormat("<change:resource key="homePageReportFound"/>");
				var text = document.createTextNode(currentPage + " " + formatter.format(messageSubsitutionValues));
				td.removeChild(td.firstChild);
				td.appendChild(text);
				
				var resultTarget = dojo.byId(currentPage + "_text");
				resultTarget.style.width = '100%';
				resultTarget.innerHTML = '<div>' + results + '</div>';
				resultTarget.className = "reportBody";
				
				results = null;

				scanOfflineDatabases();
			}
			else
			{
				if (!failSilently)
				{
					alert("<change:resource key="failedToRunHomePageReport"/>");
				}
			}
	
			currentlyLoadingReport++;
			loadReports(false);
		};
	};
}

function pageLoad()
{	
	console.debug("Testing *************************************");

	// Text selection is default behavior in IE, this looks very odd 
	// while user does drag and drop. So disabling text selection for IE. 
	// No such issues in FF. 
	if (dojo.isIE) document.onselectstart = function() 
	{
		return false;
	}
	
	if ((homePage.adminDefined) && (!asAdmin))
	{
		var homePageDeleteLink = dojo.byId("homePageDelete");
		
		homePageDeleteLink.disabled = true;
		homePageDeleteLink.style.color= "gray";
		homePageDeleteLink.style.cursor= "default";
		homePageDeleteLink.href = "#";
	}
	
	for (var i = 0; i < homePage.reports.length; i++)
	{
		var dropArea = document.getElementById(homePage.reports[i].dropArea);
		var div = createReportDiv(homePage.reports[i]);
		
		if (dropArea)
		{
			dropArea.appendChild(div);
		}	
	}
	
	loadReports(false);
	
	var refreshTime = 1000 * 60 * 20; //20 minutes
	setInterval("reloadReports()", refreshTime);
}

// compare two arrays for membership equality.
Array.prototype.equals = function(other)
{
	if (this.length != other.length) return false;

	for (var i = 0; i < this.length; i++)
	{
		if (this[i] != other[i]) return false;
	}

	return true;
};

// expands a "more..." link
function moreOfflineDatabases(link)
{
	var p = link.parentNode;
	p.getElementsByTagName('a')[0].style.display = 'none';
	p.getElementsByTagName('span')[0].style.display = '';
}

// builds as an warning message about the given offline databases and adds to page.
function updateOfflineDatabases(dbs)
{
	if (window.lastOfflines && window.lastOfflines.equals(dbs)) return;
	window.lastOfflines = dbs;

	var holder = document.getElementById('offline-parent');
	
	HomePageUtilsAjax.renderOfflineWarning(dbs, function(warningHtml)
		{
			holder.innerHTML = warningHtml;
			
			<%-- 
			hack for IE. Even if the there is no displayable HTML, IE will
			add whitespace to the page. So, skip displaying "empty" warnings--
			only show if there is a non SCRIPT node (normally a DIV) to actually show.
			--%>
			for (var i = holder.firstChild; i != null; i = i.nextSibling)
			{
				if (i.nodeName != 'SCRIPT')
				{
					holder.style.display = '';
				}
			}
		});
	
	var panel = window.top.panel ||
		(window.top.opener && window.top.opener.top.panel);
	panel && panel.setOfflineDatabases(dbs);

}

// looks for any offline databases embedded into hidden lists.
// These are embedded in the html report results sometimes.
function scanOfflineDatabases()
{
	var dbs = {};
	var uls = getElementsByClassName(document, 'offline-list');

	if (uls.length == 0) return;
	
	for (var i = 0; i < uls.length; i++)
	{
		var lis = uls[i].getElementsByTagName('li');

		for (var j = 0; j < lis.length; j++)
		{
			dbs[lis[j].innerHTML] = true;
		}
	}

	var uniques = [];
	for (var db in dbs)
	{
		uniques.push(db);
	}

	updateOfflineDatabases(uniques);
}

function reloadReports()
{
	currentlyLoadingReport = 0;
	loadReports(true);
}

function pageUnload()
{
	cancelLoading = true;
	
	if (currentRequestId != -1)
	{
		window.document.cancel_form.long_request_id.value = currentRequestId;
		window.document.cancel_form.submit();
	}
}

dojo.addOnLoad(pageLoad);
dojo.addOnUnload(pageUnload);
	</script>

<change:wsletExpander>	
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=INTEGRATION_APPLET_ONLY -->
	<!-- PARAM NAME=user_framework/report_cm_dropdown_menu.js -->
	<!-- PARAM NAME=SUB_USE_FORM_TOKEN VALUE=false -->
	<!-- /WSLET -->
</change:wsletExpander>	
	
</head>
<body class="tundra">

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=INTEGRATION_APPLET_ONLY -->
	<!-- PARAM NAME=user_framework/sc_cm_applet.inc -->
	<!-- /WSLET -->
</change:wsletExpander>	

<table width="100%" class="barHeading" id="heading">
<tr>
	<th><change:resource key="homePage"/><span id="name">&nbsp;&#151;&nbsp;<c:out value="${homePage.name}"></c:out></span></th>

	<td align="right">
		<a href="javascript: editHomePage_onclick()"><change:resource key="editHomePage"/></a>
		|
		<a href="javascript: deleteHomePage_onclick()" id="homePageDelete"><change:resource key="deleteHomePage"/></a>
	</td>
</tr>
</table>

<div id="offline-parent" style="display: none;"></div>

<c:if test="${homePage.specifiedColumnWidths == 'true'}" var="specifiedColumnWidths"/>

<table width="100%" cellspacing="0" cellpadding="5">
	<c:choose>
		<c:when test="${homePage.pageLayout == 'singleRow'}">
			<tr>
				<td>
					<div id="drop1" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>	
			</tr>
		</c:when>
		<c:when test="${homePage.pageLayout == 'dualColumn'}">
			<tr>
				<td valign="top" <c:if test="${specifiedColumnWidths}">width="${homePage.firstColumnWidth}%"</c:if> >
					<div id="drop1" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>
				<td valign="top" <c:if test="${specifiedColumnWidths}">width="${homePage.secondColumnWidth}%"</c:if>>
					<div id="drop2" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>
			</tr>
		</c:when>
		<c:when test="${homePage.pageLayout == 'rowDualColumn'}">
			<tr>
				<td colspan="2">
					<div id="drop1" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>	
			</tr>
			<tr>
				<td valign="top" <c:if test="${specifiedColumnWidths}">width="${homePage.firstColumnWidth}%"</c:if>>
					<div id="drop2" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>
				<td valign="top" <c:if test="${specifiedColumnWidths}">width="${homePage.secondColumnWidth}%"</c:if>>
					<div id="drop3" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>
			</tr>
		</c:when>
		<c:when test="${homePage.pageLayout == 'dualColumnRow'}">							
			<tr>
				<td valign="top" <c:if test="${specifiedColumnWidths}">width="${homePage.firstColumnWidth}%"</c:if>>
					<div id="drop1" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>
				<td valign="top" <c:if test="${specifiedColumnWidths}">width="${homePage.secondColumnWidth}%"</c:if>>
					<div id="drop2" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>
			</tr>
			<tr>
				<td valign="top" colspan="2">
					<div id="drop3" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>	
			</tr>
		</c:when>
		<c:when test="${homePage.pageLayout == 'twoRowDualColumn'}">
			<tr>
				<td colspan="2">
					<div id="drop1" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>	
			</tr>						
			<tr>
				<td valign="top" <c:if test="${specifiedColumnWidths}">width="${homePage.firstColumnWidth}%"</c:if>>
					<div id="drop2" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>
				<td valign="top" <c:if test="${specifiedColumnWidths}">width="${homePage.secondColumnWidth}%"</c:if>>
					<div id="drop3" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>
			</tr>
			<tr>
				<td colspan="2">
					<div id="drop4" dojoType="dojo.dnd.Source" withHandles="true" checkAcceptance="return true;" accept='*' class="dropZone">
					</div>
				</td>	
			</tr>
		</c:when>
	</c:choose>
</table>

<form name="createHomePage"
	action="<change:urlCreator webResource='BASEURL'/>/createHomePage.do"
	class="hiddenForm" method="POST" TARGET="_self"><input
	name="token" type="hidden" value="${user.token}"> <input
	name="actionFlag" type="hidden" value="pageLayout"> <input
	name="asAdmin" type="hidden" value="${asAdmin}"> <input
	name="editMode" type="hidden" value="true"> <input
	name="homePageTitle" type="hidden"></form>

<form name="cancel_form"
	action="<change:urlCreator webResource='PTACTION'/>" class="hiddenForm"
	method="POST" TARGET="hiddenFrame"><input name="token"
	type="hidden" value="${user.token}"> <input name="ACTION_FLAG"
	type="hidden" value="pt_cancel"> <input name="long_request_id"
	type="hidden" value="NO_ACTION"></form>

<form name="editHomePageReport"
	action="<change:urlCreator webResource='BASEURL'/>/homePageReportEditLoad.do"
	class="hiddenForm" method="POST" TARGET="_self"><input
	name="token" type="hidden" value="${user.token}"> <input
	name="homePageName" type="hidden"> <input
	name="homePageReportName" type="hidden"> <input
	name="isAdminDefined" type="hidden" value="${homePage.adminDefined}">
<input name="asAdmin" type="hidden" value="${asAdmin}"></form>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=custom_controls/matrixReport.CUSTOM -->
	<!-- /WSLET -->
</change:wsletExpander>
</body>
</html>
