<!-- forms\user_framework\home_page_report_edit.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<html>
<head>
	<title></title>
	
	<style type="text/css">

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/default.css -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/tabs.css -->
	<!-- /WSLET -->
</change:wsletExpander>

	</style>
	
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	
	<script type="text/javascript">

var report = new Object();
report.name = <change:javaScriptEscape value="${reportEntry.name}"/>;
report.description = <change:javaScriptEscape value="${reportEntry.description}"/>;
report.style = <change:javaScriptEscape value="${reportEntry.style}"/>;
report.sub_reports = new Array();

<c:forEach items="${reportEntry.subReports}" var="subReport" varStatus="status">
	report.sub_reports[${status.index}] = new Object();
	report.sub_reports[${status.index}].name = <change:javaScriptEscape value="${subReport.name}"/>;
	report.sub_reports[${status.index}].attributes = <change:javaScriptEscape value="${subReport.attributesAsString}"/>;
	report.sub_reports[${status.index}].def_type = ${subReport.definitionType};
	report.sub_reports[${status.index}].def_type_string = "${subReport.definitionTypeAsString}";
	report.sub_reports[${status.index}].label_template = <change:javaScriptEscape value="${subReport.labelTemplate}"/>;
	report.sub_reports[${status.index}].sort_order = <change:javaScriptEscape value="${subReport.sortOrderAsString}"/>;
</c:forEach>

<c:set var="queryEntry" value="${reportEntry.queryEntry}" />
report.query = new Object();
report.query.name = <change:javaScriptEscape value="${queryEntry.name}"/>;
report.query.description = <change:javaScriptEscape value="${queryEntry.description}"/>;
report.query.query_string = <change:javaScriptEscape value="${queryEntry.queryString}"/>;

var homePageReports = new Array();

<c:forEach items="${reports}" var="reportItem" varStatus="status">
homePageReports[${status.index}] = <change:javaScriptEscape value="${reportItem.name}"/>;
</c:forEach>

function getReportJson()
{
	return dojo.toJson(report);
}

function tab_onclick(a)
{
	if (a.disabled)
	{
		return;
	}
	
	var li = a.parentNode;
	var siblings = li.parentNode.getElementsByTagName("li");

	for (var i = 0; i < siblings.length; i++)
	{
		var sibling = siblings[i];

		if (sibling == li)
		{
			sibling.getElementsByTagName("a")[0].className = "current";
			displayCorrectIFrame(i);
		}
		else
		{
			sibling.getElementsByTagName("a")[0].className = "";
		}
	}
}

// Display the iframe that needs to be displayed and hide the others.
// 0 = Query
// 1 = Format
// 2 = Name
function displayCorrectIFrame(selectedIndex)
{
	if (selectedIndex == 0)
	{
		document.getElementById("queryFrame").style.display = "";
		document.getElementById("formatFrame").style.display = "none";
		document.getElementById("nameFrame").style.display = "none";
	}
	else if (selectedIndex == 1)
	{
		var formatFrame = document.getElementById("formatFrame");
		formatFrame.style.display = "";
		//Dojo complains when a frame is hidden when it loads, so we set the initial size
		//to 0% height and width, now we fix it the first time we load.
		if (formatFrame.style.width == "0%")
		{
			formatFrame.style.width = "100%";
			formatFrame.style.height = "85%";
		}
		
		document.getElementById("queryFrame").style.display = "none";
		document.getElementById("nameFrame").style.display = "none";
	}
	else
	{
		document.getElementById("nameFrame").style.display = "";
		document.getElementById("queryFrame").style.display = "none";
		document.getElementById("formatFrame").style.display = "none";
		
		//JavaScript won't let you just call the iframes functions directly, you have to get a handle
		//to the contentWindow of the iframe first.
		//special handling to give focus and highlight report name.
		var nameFrame = document.getElementById("nameFrame").contentWindow;
		nameFrame.onDisplay();
	}
}

function save_onclick()
{
	if (!canSave())
	{
		return false;
	}
}

function canSave()
{
	//JavaScript won't let you just call the iframes functions directly, you have to get a handle
	//to the contentWindow of the iframe first.
	var queryFrame = document.getElementById("queryFrame").contentWindow;
		
	if (!queryFrame.canQuery())
	{
		return false;
	}
	
	var formatFrame = document.getElementById("formatFrame").contentWindow;
		
	if (!formatFrame.canSave())
	{
		return false;
	}
	
	var nameFrame = document.getElementById("nameFrame").contentWindow;
	var newName = dojo.trim(nameFrame.getReportName());
	
	if (newName.length == 0)
	{
		alert("<change:resource key='specifyReportName'/>");
		return false;
	}
	else
	{	
		var oldNameLower = report.name.toLowerCase();
		var newNameLower = newName.toLowerCase();

		if (oldNameLower !== newNameLower)
		{
			for (var i = 0; i < homePageReports.length; i++)
			{
				if (homePageReports[i].toLowerCase() === newNameLower)
				{
					alert("<change:resource key='homePageReportNameInUse'/>");
					return false;
				}
			}
		}
	}
	
	var updateObject = getUpdateObject(newName);
	
	if (!hasBeenUpdated(updateObject))
	{
		alert("<change:resource key='noHomePageReportChanges'/>");
		return;
	}
	
	window.document.reportSave.homePageName.value = <change:javaScriptEscape value="${homePageName}"/>;
	window.document.reportSave.reportAsJSON.value = dojo.toJson(updateObject);
	window.document.reportSave.submit();
}

function getUpdateObject(reportName)
{
	var newReportName = "";
	
	if (report.name != reportName)
	{
		newReportName = reportName;
	}

	var updateObject = new Object();
	updateObject.originalReportName = report.name;
	updateObject.newReportName = newReportName;
	updateObject.queryString = queryFrame.getQueryString();
	updateObject.attributes = new Array();
	updateObject.sortOrder = new Array();
	
	for (var i = 0; i < report.sub_reports.length; i++)
	{
		updateObject.attributes[i] = formatFrame.getAttributes(i);
		updateObject.sortOrder[i] = formatFrame.getSortOrder(i);
	}
	
	return updateObject;
}

function hasModifications()
{
	var nameFrame = document.getElementById("nameFrame").contentWindow;
	var reportName = dojo.trim(nameFrame.getReportName());
	var updateObject = getUpdateObject(reportName);
	
	return hasBeenUpdated(updateObject);
}

function hasBeenUpdated(updateObject)
{
	if (updateObject.newReportName.length > 0)
	{
		if (updateObject.originalReportName !== updateObject.newReportName)
		{
			return true;
		}
	}
	
	if (updateObject.queryString != report.query.query_string)
	{
		return true;
	}
	
	for (var i = 0; i < report.sub_reports.length; i++)
	{
		if (report.sub_reports[i].attributes != updateObject.attributes[i])
		{
			return true;
		}
		
		if (report.sub_reports[i].sort_order != updateObject.sortOrder[i])
		{
			return true;
		}
	}
	
	return false;
}

function initialize()
{
	loadQueryFrame();
}

function loadQueryFrame()
{
	window.document.formLoader.target = "queryFrame";
	window.document.formLoader.formName.value = "homePageReportQueryEditor";
	window.document.formLoader.submit();
	
	window.setTimeout(loadFormatFrame, 50);
}

function loadFormatFrame()
{
	window.document.formLoader.target = "formatFrame";
	window.document.formLoader.formName.value = "homePageReportFormatEditor";
	window.document.formLoader.submit();
	
	window.setTimeout(loadNameFrame, 50);
}

function loadNameFrame()
{
	window.document.formLoader.target = "nameFrame";
	window.document.formLoader.formName.value = "homePageReportNameEditor";
	window.document.formLoader.submit();
}

	</script>

</head>

<body onload="initialize()">

<div id="tabs">
	<ul id="tabsList" class="tabbedList">
		<li><a id="queryTab" href="#" onclick="tab_onclick(this);" class="current"><change:resource key="lbl01098"/></a></li>
		<li><a id="formatTab" href="#" onclick="tab_onclick(this);"><change:resource key="lbl01099"/></a></li>
		<li><a id="nameTab" href="#" onclick="tab_onclick(this);"><change:resource key="nameTab"/></a></li>
	</ul>
</div>

<iframe src="<change:urlCreator webResource='JS'/>dojo/dojo/resources/blank.html" name="queryFrame" id="queryFrame" frameborder="0" style="width: 100%; height: 85%; padding: 0px; margin: 0px;"></iframe>
<iframe src="<change:urlCreator webResource='JS'/>dojo/dojo/resources/blank.html" name="formatFrame" id="formatFrame" frameborder="0" style="width: 0%; height: 0%; padding: 0px; margin: 0px;"></iframe>
<iframe src="<change:urlCreator webResource='JS'/>dojo/dojo/resources/blank.html" name="nameFrame" id="nameFrame" frameborder="0" style="width: 100%; height: 85%; padding: 0px; margin: 0px; display: none"></iframe>

<hr />

<div style="text-align: center">
	<button onclick="save_onclick()"><change:resource key="lbl00592"/></button>
</div>

<form name="formLoader" action="<change:urlCreator webResource='BASEURL'/>/formLoader.do" class="hiddenForm" method="POST">
	<input name="token" type="hidden" value="${user.token}">
	<input name="formName" type="hidden" value="browse">
</form>

<form name="reportSave" action="<change:urlCreator webResource='BASEURL'/>/updateHomePageReport.do" class=hiddenForm" method="POST">
	<input name="token" type="hidden" value="${user.token}">
	<input name="isAdminDefined" type="hidden" value="${isAdminDefined}">
	<input name="asAdmin" type="hidden" value="${asAdmin}">
	<input name="homePageName" type="hidden">
	<input name="reportAsJSON" type="hidden">
</form>

</body>
</html>
