if (!window.EventUtils) alert("Shybox requires EventUtils.js");
if (!window.StyleUtils) alert("Shybox requires StyleUtils.js");

function Shybox(){}

Shybox.show = function(shybox)
{
	function shim(shybox)
	{
		var shim = document.createElement('iframe');

		shim.src = "<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=JS_PATH --><!-- /WSLET -->dojo/dojo/resources/blank.html";
		shim.style.width = (shybox.clientWidth != null)
			? shybox.clientWidth + 'px'
			: StyleUtils.getComputedStyle(shybox, 'width', 'width');
		shim.style.height = StyleUtils.getComputedStyle(shybox, 'height', 'height');
		shim.style.position = 'absolute';
		
		shim.style.top = StyleUtils.getComputedStyle(shybox, 'top', 'top');
		shim.style.left = StyleUtils.getComputedStyle(shybox, 'left', 'left');

		shybox.parentNode.insertBefore(shim, shybox);
		shybox.shim = shim;
	}
	
	var arrow = shybox._Shybox_arrow;
	var textbox = shybox._Shybox_textbox;

	if (arrow)
	{
		// everything is relative to the arrow the user clicks
		var arrowWidth = arrow.offsetWidth;

		if (textbox)
		{
			// make as wide as arrow image and textbox
			shybox.style.width = arrowWidth + textbox.offsetWidth + 'px';
		}

		//setting for value shybox in ACLs tab		
		var arrowPos = dojo.coords(arrow);

		shybox.style.top = arrowPos.y + arrow.offsetHeight + 'px';
		
		var ieNudge = (document.all)
			? 2
			: 0;

		var menuWidth = shybox.offsetWidth;
		shybox.style.left = Math.round(arrowPos.x + arrowWidth - menuWidth + ieNudge) + 'px';		
	}
	
	if (document.all && !window.XMLHttpRequest)
	{
		// fix the show-through SELECTs in IE 6
		shim(shybox);
	}

	if (shybox.selectedIndex > -1)
	{
		shybox.options[0].selected = true;
		shybox.selectedIndex = -1;
	}
	
	shybox.style.visibility = 'visible';

	var focusFunction = function()
	{
		shybox.focus();
	};

	// this "delay" keeps IE from sending multiple blur events which hide the menu too often
	window.setTimeout(focusFunction, 0);
	
};

Shybox.hide = function(shybox)
{
	shybox.selectedIndex = -1;
	shybox.style.visibility = 'hidden';

	if (shybox.shim)
	{
		shybox.parentNode.removeChild(shybox.shim);
		shybox.shim = null;
	}
};

Shybox.shybox_onBlur = function(e)
{
	var shybox = EventUtils.getTarget(e);

	Shybox.hide(shybox);
};

Shybox.getSelectedValue = function(shybox)
{
	var index = shybox.selectedIndex;
	
	if (index == -1) return null;

	return shybox.options[shybox.selectedIndex].value;
};

Shybox.fireValueChange = function(shybox)
{
	var listener = shybox.valueListener;

	if (!listener) return;
	
	var value = Shybox.getSelectedValue(shybox)
	shybox.selectedIndex = -1;
	
	if (value)
	{
		listener.value = value;
	}

	listener.focus();
};

Shybox.setValue = function(shybox, value)
{
	shybox.valueListener.value = value;
};

Shybox.text_onKeyDown = function(e)
{
	var target = EventUtils.getTarget(e);
	var event = EventUtils.getEvent(e);
	
	// show on 'down arrow'
	if (event.keyCode == 40) 
	{
		Shybox.show(target.shybox);
		EventUtils.preventDefault(e);
	}
};

Shybox.shybox_onKeydown = function(e)
{
	var shybox = EventUtils.getTarget(e);
	var event = EventUtils.getEvent(e);
	
	switch (event.keyCode)
	{
		case 13:	// Enter
			Shybox.fireValueChange(shybox);
			Shybox.hide(shybox);
			break;
		case 27:	// esc
			Shybox.hide(shybox);
			break;
	}	
};

Shybox.shybox_onClick = function(e)
{
	var target = EventUtils.getTarget(e);

	// normalize click event between IE, Firefox
	var shybox = (target.tagName == 'OPTION')
		? target.parentNode
		: target;

	Shybox.fireValueChange(shybox);
	Shybox.hide(shybox);
};

Shybox.option_onMouseover = function(e)
{
	var option = EventUtils.getTarget(e);
	
	// this make it look more like an interactive menu, but doesn't work in IE
	option.selected = true;
};

Shybox._notifyIfTextChanged = function(e)
{
	var textbox = EventUtils.getTarget(e);
	
	if (textbox._Shybox_onChangeListener)
	{
		if (textbox._Shybox_initialValue
			!= textbox.value)
		{
			textbox._Shybox_onChangeListener();
		}
	}
};

/**
 * Convert a regular listbox (SELECT) into a shybox, which is similar to a combobox.
 * @listbox the listbox to convert
 * @optionalInitialValue the initial value to show in the textfield.
 * @optionalOnInitialChangeListener a listener function called after a blur when the text value
 *		has changed from the initial value. This is a bit of a hack to "dirty" the ACL editor.
 *		Avoid using this in other places if possible until we make this nicer.
 */
Shybox.convertToShybox = function(listbox, optionalInitialValue, optionalOnInitialChangeListener)
{
	var parent = listbox.parentNode;

	var frag = document.createDocumentFragment();

	// 2) create the input for the user to edit
	var textbox = document.createElement('INPUT');
	textbox.type = 'text';
	StyleUtils.addClass(textbox, 'shybox-text');
	if (optionalInitialValue)
	{
		textbox._Shybox_initialValue = optionalInitialValue;
		textbox.value = optionalInitialValue;
	}
	if (optionalOnInitialChangeListener)
	{
		EventUtils.addEvent(textbox, 'blur', Shybox._notifyIfTextChanged);
		textbox._Shybox_onChangeListener = optionalOnInitialChangeListener;
	}

	EventUtils.addEvent(textbox, 'keydown', Shybox.text_onKeyDown);
	// give the textbox and easy reference to the select box to ease showing it later
	textbox.shybox = listbox;
	listbox.valueListener = textbox;
	if (listbox.size < 2) listbox.size = 10;
	// 3) massage the select box
	StyleUtils.addClass(listbox, 'shybox');

	EventUtils.addEvent(listbox, 'click', Shybox.shybox_onClick);
	EventUtils.addEvent(listbox, 'blur', Shybox.shybox_onBlur);
	EventUtils.addEvent(listbox, 'keydown', Shybox.shybox_onKeydown);

	var options = listbox.options;
	
	for (var i = 0; i < options.length; i++)
	{
		// this only works in Firefox, but it makes the options work like menu options
		// with auto highlighting
		EventUtils.addEvent(options[i], 'mouseover', Shybox.option_onMouseover, false);
	}
	
	// 4) add arrow control to reveal the hidden select	
	var showFunction = function(e)
	{
		Shybox.show(listbox);
	};

	var arrowImg = document.createElement('IMG');
	arrowImg.src = '<!-- WSLET CODE=PTAdmin --><!-- PARAM NAME=SERVLET_PATH VALUE=PTIMAGES_PATH --><!-- /WSLET -->shybox_arrow.gif';
	arrowImg.className = 'shybox-arrow';
	EventUtils.addEvent(arrowImg, 'click', showFunction);
	
	// 5) assemble and return
	frag.appendChild(textbox);
	document.body.appendChild(listbox);
	frag.appendChild(arrowImg);

	listbox._Shybox_arrow = arrowImg;
	listbox._Shybox_textbox = textbox;
	
	parent.appendChild(frag);
	return frag;
};
